import astropy,os,scipy,scipy.interpolate,sys,scipy.signal,math
#import matplotlib.pyplot as plt
import numpy as np
from astropy.io import fits
from scipy import interpolate
from scipy.interpolate import Rbf
from scipy.signal import savgol_filter
from scipy.ndimage import gaussian_filter1d
#from matplotlib import cm

x=np.empty(10)
y=np.empty(10)
xx=np.linspace(0,4031,4032)
yy=np.linspace(0,4095,4096)
#raw_input()

struct = np.empty((16,4032,4096),dtype=np.float32)
sky_smooth = np.empty((4032,4096),dtype=np.float32)
struct[0,:,:]=fits.open('../struct-ccd1-g-image.fits')[0].data
struct[1,:,:]=fits.open('../struct-ccd2-g-image.fits')[0].data
struct[2,:,:]=fits.open('../struct-ccd3-g-image.fits')[0].data
struct[3,:,:]=fits.open('../struct-ccd4-g-image.fits')[0].data

os.system("ls p????[g,z,u,r]??????.fits > fits.lst")
os.system("ls p????bokr??????.fits >> fits.lst")

for line in open("fits.lst"):
    filename=line.strip("\n")
    j=filename[11:12]

    object=fits.open(filename)
    data=object[0].data

    dmedian=np.median(data[100:4000,100:4000])
    dstd=np.std(data[100:4000,100:4000])
    sky_median=np.empty((10,10))

    a=abs(data-dmedian)

#    for i in range(4096):
#        for j in range(4032):
#            if (math.isnan(a[i,j])):
#                print i,j,data[i,j]
#                raw_input()

    mask=(a<=1*np.sqrt(dmedian))
    mask_int=1*mask

    sky=data*mask_int-(mask_int-1)*dmedian

    for m in range(10):
        for n in range(10):
            sky_median[m,n]=np.median(sky[m*400+16,n*400+48])

    for i in range(10):
        x[i]=i*400+16+200
        y[i]=i*400+48+200

#    print(x,y)

#    print(sky_median)

#    sky_smooth=scipy.ndimage.filters.gaussian_filter(sky,200)

    rect_spline=scipy.interpolate.RectBivariateSpline(x,y,sky_median,kx=3,ky=3)

    sky_smooth=rect_spline(xx,yy)
#    print(rect_spline(100,100))

#    print(data[1000,1000],sky_smooth[1000,1000],struct[j,1000,1000],dmedian)
    data=(data-sky_smooth)*struct[j,:,:]+dmedian#3337,285
#    print(data[1000,1000])
    hdu=fits.PrimaryHDU(sky)
    hdu1=fits.PrimaryHDU(np.float32(sky_smooth))

    hdu.writeto('mask.fits',clobber='Ture')
    line1=filename[:-5]+'_sky.fits'
    hdu1.writeto(line1,clobber='Ture')

    object.writeto('s'+filename[1:],clobber='Ture')
    print(filename,dmedian,np.sqrt(dmedian))
    
